#!/bin/bash
#cd raw
#   Processing Fuji S500 images, subtracting dark frames, which should 
#    exist already including their pgm and
#    whose names are to be introduced by alone standing 'D' 

#mkdir pgm


D=N
DN=
DNp=
ON=
SN=
for F in $@
do
 if [ "$F" == "D" ] ||  [ "$F" == "O" ] ||  [ "$F" == "S" ]
  then
# first parameter should be D, second the dark frame number
   if  [ "$F" == "D" ]
   then    
    echo "D found"
    D=D
   elif  [ "$F" == "S" ]
   then    
    echo "S found"
    D=S
   else 
    echo "O found"
    D=O
   fi    
  elif 
   [ "$D" == "D" ] || [ "$D" == "O" ] || [ "$D" == "S" ] 
  then
   if [ "$D" == "D" ] 
   then
    if [ "$F" == "-" ]
    then
     DN=
     DNp=
    else  
     DN="-d pgm/$F.pgm" 
     DNp=$DN
    fi 
    echo "darkframe set to $F"
    D=N
   elif [ "$D" == "S" ] 
   then
    if [ "$F" == "-" ]
    then
     SN=
    else
     SN=$F  
     DN=$DNp:$SN 
    fi 
    echo "Scaling set to $F"
    D=N
   else
    if [ "$F" == "-" ]
    then
     ON=
    else
     ON="-o dark/$F.pgm"
    fi 
    echo "offset frame set to $F"
    D=N
   fi    
  else
   echo "processing image $F"

H=${F}a

echo "raw2lumf -c fuji -t 118 $ON $DN  -fa -sm100:16 \
 -i $F.txt -e $H.eps -n $H.ppm \
 -s71:76 pgm/$F.pgm > $H.td"

 raw2lumf -c fuji -t 118  $ON $DN  -fa -sm100:16 \
 -i $F.txt -e $H.eps -n $H.ppm  -nh \
 -s71:76 pgm/$F.pgm > $H.td

tail $H.td

convert $H.ppm $H.png

convert -negate $H.eps /tmp/n.png  

  sed '2 s/1424 1076/1280 967\
  1280 1424 div dup scale/' $H.eps >/tmp/$F.eps
  
  convert -negate /tmp/$F.eps /tmp/n.png  
  composite -compose Difference /tmp/n.png $F.jpeg ${F}ga.jpg
  
  composite -compose Multiply $F.eps $H.png ${F}ga.png

rm $H.ppm

 fi
done

#res_listnikd

#zgv

